%global date 20230419
%global commit 392b960e0d12d222e862a3e9b65c6e5b455e7087
%global shortcommit %(c=%{commit}; echo ${c:0:7})
# We use the GitHub mirror here because it's easier to get a tarball from it
%global forgeurl https://github.com/marlam/glfract-mirror
%global srcname glfract-mirror

Name:           glfract
Version:        0.2~%{date}git%{shortcommit}
Release:        %autorelease
Summary:        Experimental program to explore Mandelbrot fractal set images

License:        GPL-3.0-or-later
URL:            https://marlam.de/glfract
Source:         %{forgeurl}/archive/%{commit}/%{srcname}-%{commit}.tar.gz

BuildRequires:  cmake
BuildRequires:  gcc-c++

BuildRequires:  libGL-devel
BuildRequires:  libquadmath-devel
BuildRequires:  libxkbcommon-devel
BuildRequires:  qt6-qtbase-devel

Suggests:       gencolormap

# libquadmath isn't available on these arches
ExcludeArch:    aarch64 s390x

%description
This is an experimental program to explore Mandelbrot fractal set images. The
fractals are computed on the GPU using one of the following precisions:
- single precision
- extended precision based on 2x single precision
- double precision
- extended precision based on 2x double precision

The main purpose of this program is to test the 2x single or double precision
modes. The 2x single precision mode produces results that are comparable with
double precision mode, but uses only single precision machine instructions and
is therefore often faster (depending on the GPU).

%prep
%autosetup -p1 -n %{srcname}-%{commit}

%build
%cmake
%cmake_build

%install
%cmake_install

%files
%license LICENSE
%doc README.md
%{_bindir}/%{name}

%changelog
%autochangelog
